/*-----------------------------------------------------------------------------
Pragma's
-----------------------------------------------------------------------------*/
//#include "stdafx.h"


/*-----------------------------------------------------------------------------
Interface Include file
-----------------------------------------------------------------------------*/
#include "Timer.h"

 
/*-----------------------------------------------------------------------------
Includes for Implementation 
-----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
Globals
-----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
Assumption: CPUID instruction is actually supported.
-----------------------------------------------------------------------------*/
unsigned int CTimer::GetTicks(void)
{
	unsigned int Elapsed;
	_asm //Taken from AMD SDK
	{
		xor    eax, eax
		xor    ebx, ebx
		xor    ecx, ecx
		xor    edx, edx
		_emit  0x0f				// CPUID
		_emit  0xa2
		_emit  0x0f				// RDTSC
		_emit  0x31
		mov    [Elapsed], eax
	}
	return Elapsed;
}
